require 'apiotics/configuration'
require "apiotics/version"
require 'apiotics/server'
require 'apiotics/client'
require 'apiotics/parse'
require 'apiotics/insert'
require 'apiotics/extract'
require 'apiotics/portal'
require 'apiotics/hardware'
require 'daemons'

module Apiotics
  
  class << self
    attr_accessor :configuration
  end
  
  def self.configuration
    @configuration ||= Configuration.new
  end
  
  def self.reset
    @configuration = Configuration.new
  end
  
  def self.configure
    yield(configuration)
  end
  
  def self.get(object, time0= nil, time1= nil)
    Apiotics::Extract.get(object, time0, time1)
  end
  
  def self.get_attributes(parent_name, model_name)
    configuration = Apiotics::Portal.retrieve_configuration
    attributes = Apiotics::Portal.parse_drivers_and_scripts(configuration, parent_name, model_name)
  end
  
  def self.sync_device_instances(worker_name, sync_data= false)
    Apiotics::Portal.sync_device_instances(worker_name, sync_data)
  end
  
  def self.sync(object)
    parent = object.class.parent.name
    child = object.class.name.demodulize
    attributes = Apiotics.configuration.targets[parent][child]
    interfaces = Hash.new
    attributes.each do |attribute|
      interfaces[attribute.underscore.downcase.gsub(" ", "_")] = object.send(attribute.underscore.downcase.gsub(" ", "_")).to_s
    end
    Apiotics::Extract.fire(object, interfaces, "get")
  end
  
  def self.clear_settings
    ApioticsSetting.destroy_all
  end
    
end
