module Apiotics
  class ChannelGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string
  
    def copy_channel_files
      template "apiotics_channel.rb.erb", "app/channels/#{module_file_name}_channel.rb"
      template "apiotics_channel_client.coffee.erb", "app/assets/javascripts/channels/#{module_file_name}.coffee"
      template "apiotics_channel_initializer.rb.erb", "config/initializers/apiotics_channel.rb"
      route "mount ActionCable.server => '/cable'"
    end
    
    private
    
    def file_name
      name.underscore
    end
    
    def module_file_name
      parent.underscore
    end
    
    def class_name
      name.classify
    end
    
    def module_name
      parent.classify
    end
    
    def table_prefix
      parent.underscore + "_"
    end
  end
end