module Apiotics
  class ControllerGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string
  
    def copy_scaffold_files
      @models = Apiotics.configuration.targets[module_name.to_s]
      template "apiotics_scaffold.rb.erb", "app/controllers/#{module_file_name}/#{module_file_name.pluralize}_controller.rb"
      generate "apiotics:view", "#{parent}"
      route "scope module: :#{module_file_name} do \n\t\tresources :#{module_file_name}s\n\tend"
      generate "simple_form:install"
    end
    
    private
    
    def module_file_name
      parent.underscore
    end
    
    def module_name
      parent.classify
    end
    
  end
end