module Apiotics
  class InitializerGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :portal, :type => :string, :required => false
    
    def copy_initializer_file
      if portal == "true"
        @c = Apiotics::Portal.parse_all_interfaces
        template "apiotics_targets.rb.erb", "config/initializers/apiotics_targets.rb"
        @p = Apiotics::Portal.parse_parents
        template "apiotics_parents.rb.erb", "config/initializers/apiotics_parents.rb"
      else
        template "apiotics.rb.erb", "config/initializers/apiotics.rb"
        template "apiotics_settings.rb.erb", "db/migrate/#{date_string}_create_apiotics_settings.rb"
        template "setting.rb.erb", "app/models/apiotics_setting.rb"
        #template "apiotics_module.rb.erb", "app/models/apiotics.rb"    
      end
    end


    
    private

    def date_string
      date_string = DateTime.now.strftime("%Y%m%d%H%M%S")
    end    
    
  end
end