module Apiotics
  class MigrationGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :name, :type => :string
    argument :attributes, :type => :hash, :required => true
  
    def copy_create_table_files
      template "migrate_table.rb.erb", "db/migrate/#{date_string}_#{underscore_name}.rb"
      sleep 1
      attributes.each do |k,v|
        @k = k
        @v = v
        template "create_logs_table.rb.erb", "db/migrate/#{date_string}_#{underscore_name}_logs.rb"
        sleep 1
      end
    end
    
    private
    
    def date_string
      date_string = DateTime.now.strftime("%Y%m%d%H%M%S")
    end
  
    def table_name
      array = name.underscore.split('_')
      i = 0
      new_array = Array.new
      marker = false
      while i < array.length
        if marker == true
          new_array << array[i]
        end
        if array[i] == "to"
          marker = true
        end
        i += 1
      end
      new_array.join('_')
    end
  
    def underscore_name
      name.underscore
    end
  
    def class_name
      name.classify
    end
  
    def logs_table_name(k)
      table_name + "_" + k.underscore + "_" + "logs"
    end
  
  end
end
