module Apiotics
  class ScriptGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string, :required => false
    argument :name, :type => :string, :required => false
  
    def create_script
      if name != nil
        @c = Apiotics::Portal.get_attributes(parent, name)
        template "script.rb.erb", "lib/scripts/apiotics/#{parent_file_name}/#{file_name}.rb"
      end
      copy_file "server.rb", "lib/scripts/server.rb"
      copy_file "test_server.rb", "lib/scripts/test_server.rb"
      copy_file "dev_server.rb", "lib/scripts/dev_server.rb"
      copy_file "server_control.rb", "lib/scripts/server_control.rb"
      copy_file "test_server_control.rb", "lib/scripts/test_server_control.rb"
      copy_file "dev_server_control.rb", "lib/scripts/dev_server_control.rb"
      copy_file "comm_server.rake", "lib/tasks/comm_server.rake"
      copy_file "test_comm_server.rake", "lib/tasks/test_comm_server.rake"
      copy_file "dev_comm_server.rake", "lib/tasks/dev_comm_server.rake"
      copy_file "publish_script.rake", "lib/tasks/publish_script.rake"
      copy_file "install_firmware.rake", "lib/tasks/install_firmware.rake"
      FileUtils.chmod 0775, "lib/scripts/server_control.rb"
    end
  
    private
  
    def file_name
      name.underscore
    end
  
    def class_name
      name.classify
    end
    
    def parent_class_name
      parent.classify
    end
    
    def parent_file_name
      parent.underscore
    end
  
  end
end
