module Apiotics
  class ViewGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)
    argument :parent, :type => :string
  
    def copy_scaffold_files
      @models = Apiotics.configuration.targets[module_name.to_s]
      template "show.html.erb", "app/views/#{module_file_name}/#{module_file_name.pluralize}/show.html.erb"
      template "edit.html.erb", "app/views/#{module_file_name}/#{module_file_name.pluralize}/edit.html.erb"
      template "index.html.erb", "app/views/#{module_file_name}/#{module_file_name.pluralize}/index.html.erb"
      template "form.html.erb", "app/views/#{module_file_name}/#{module_file_name.pluralize}/_form.html.erb"
      template "default.css.erb", "app/assets/stylesheets/#{module_file_name}.css"
    end
    
    private
    
    def module_file_name
      parent.underscore
    end
    
    def module_name
      parent.classify
    end
    
  end
end